'Sept 19

'program to demo random numbers, 
'while loops and for loops 
'simulates the roll of two dice
'roll until snake eyes (two ones) 
'comes up

Imports System.IO   'so can use Directory.GetCurrentDirectory

Public Class FrmSnakeEyes

    'declare and instantiate an object of the Random class
    Dim RandomNumber As Random = New Random
    Dim Die1 As Integer
    Dim Die2 As Integer
    Dim MyLocation As String

    '*****************************************
    'simulate the roll of two dice, roll repeated until 
    'snake eyes -- two ones are rolled count the number 
    'of rolls necessary.  Call that one sample.  Repeat 
    'the process and take an average of the number of 
    'rolls to get snake eyes over the number of samples.  
    Private Sub btnRoll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRollSnakeEyes.Click
        Dim RollCount As Integer = 0

        Dim i As Integer
        Dim Sum As Integer = 0

        'perform simulation over many samples
        For i = 1 To 1000
            're-initialize variables for start of new sample
            Die1 = 0
            Die2 = 0
            RollCount = 0
            'keep rolling until get snake eyes
            Do While Die1 + Die2 <> 2
                Die1 = RandomNumber.Next(1, 7)
                'picDie1.Image = Image.FromFile(MyLocation & "\Die" & Die1 & ".gif")
                'I commented out the display it was only slowing us down 
                Die2 = RandomNumber.Next(1, 7)
                'picDie2.Image = Image.FromFile(MyLocation & "\Die" & Die2 & ".gif")
                RollCount += 1
            Loop
            Sum += RollCount

            lstStats.Items.Add(RollCount)
        Next
        lblStatAve.Text = "The average number of rolls needed to roll snake eyes is " & Sum / 1000 & "."
    End Sub

    '*****************************************
    'so we know where the exe is
    Private Sub FrmCraps_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MyLocation = Directory.GetCurrentDirectory
    End Sub

    '*******************************************
    'Simulate the roll of two dice for many samples 
    'determine the fraction of them that were snake
    'eyes.  Present that result as a percentage 
    Private Sub btnPercentage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPercentage.Click
        Dim i As Integer
        Dim SnakeEyesCount As Integer = 0

        For i = 1 To 10000
            Die1 = RandomNumber.Next(1, 7)
            Die2 = RandomNumber.Next(1, 7)
            If Die1 + Die2 = 2 Then
                SnakeEyesCount += 1
            End If
        Next
        lblPercentage.Text = "The simulated percentage of snake eyes is " & Format(SnakeEyesCount / 10000, "Percent") & "."
    End Sub

End Class
